/*

DU4LVAL.H

JY

Main interface for DU4

*/

#ifndef DU4LVAL_H_
#define DU4LVAL_H_

#include <string>
#include <queue>
#include "literal_storage.hpp"
#include "flat_icblock.hpp"
#include "dutables.h"
#include "abstract_instr.hpp"
#include "gen_ainstr.hpp"

namespace mlc {

	typedef std::queue<ls_id_type::const_iterator> VariablesQueue;

    struct Type
	{
		type_pointer                   typePointer;
		bool                           defined;
	};

	enum ConstType
	{
		_ID , _INT , _REAL , _STR
	};

	struct Const
	{
		ConstType                      constType;
		ls_id_type::const_iterator     id;
		ls_int_type::const_iterator    intVal;
		ls_real_type::const_iterator   realVal;
		ls_str_type::const_iterator    strVal;
		bool                           defined;
	};

	// compiler's semantic value
	struct MlaskalLval {
		int					dtge_;		// group element
		mlc::ls_int_type::const_iterator	int_ci_;	// const iterator into INT literal table
		mlc::ls_real_type::const_iterator	real_ci_;	// const iterator into REAL literal table
		mlc::ls_str_type::const_iterator	str_ci_;	// const iterator into STRING literal table
		mlc::ls_id_type::const_iterator		id_ci_;		// const iterator into identifier table
        Type                                typeVal_;
		VariablesQueue                      varQue_;
		parameter_list *                    formalParamList_;
		Const                               constVal_;
		field_list *                        fieldList_;
	};

	/*************************************************************/

}

// lex interface
#define YY_DECL	    int yylex(mlc::MlaskalLval *lv, unsigned *l, mlc::MlaskalCtx *ctx)
YY_DECL;

#endif
