/*

    DU5SEM.H

*/

#ifndef DU5SEM_H_
#define DU5SEM_H_

#include "du5.h"
#include "du5lval.hpp"

namespace mlc {

	//void myAddType ();
	void             myAddVar            (MlaskalCtx * ctx, VariablesQueue * ids, Type definedType, unsigned int line);
	parameter_list * myCreateParamList   (MlaskalCtx * ctx, VariablesQueue * ids, ls_id_index typeID, bool reference, unsigned int line);
	void             myAddFunction       (MlaskalCtx * ctx, ls_id_index functionID, parameter_list * params, ls_id_index typeID, unsigned int line);
	void             myAddConst          (MlaskalCtx * ctx, ls_id_index constantID, Const constantStructure, unsigned int line);
	field_list *     myCreateFieldList   (                  VariablesQueue * ids, Type definedType);
	Instruction      myMethodCall        (MlaskalCtx * ctx, ls_id_index methodID, InstructionQueue * params, bool resultRequested, unsigned int line);
	bool             myTotalConversion   (type_category target, type_category source, Instruction * result, unsigned int line);
	icblock_pointer  myRelOperResult     (int relOper, Instruction * left, Instruction * right, unsigned int line);
	Instruction      myTermsListBuild    (int termOper, Instruction * terms, Instruction * term, unsigned int line);
	Instruction      myFactorsListBuild  (int factorOper, Instruction * factors, Instruction * factor, unsigned int line);
	Instruction      myIdentifierProcess (MlaskalCtx * ctx, ls_id_index commonID, bool stor, unsigned int line);
	void             myDebug             ();

}

#endif
